/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.66 Revision 1.123
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.66 2010/03/24 14:36:28 yngwin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.123 2012/03/08 14:24:40 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
14 16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 18
17MY_PV=${PV/_/-} 19MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 20MY_P=qt-everywhere-opensource-src-${MY_PV}
21
22HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
23SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
24LICENSE="|| ( LGPL-2.1 GPL-3 )"
25
26IUSE="aqua debug pch"
27
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 28[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
21else 29[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 MY_P=qt-x11-opensource-src-${MY_PV} 30 IUSE+=" +exceptions"
31
32if version_is_at_least 4.7.99999999; then
33 IUSE+=" c++0x qpa"
23fi 34fi
24 35
25HOMEPAGE="http://qt.nokia.com/" 36DEPEND="dev-util/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND=" 37RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 38 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 39 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 40 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 41 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 42 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 43 !>x11-libs/qt-dbus-${PV}-r9999
44 !<x11-libs/qt-declarative-${PV}
45 !>x11-libs/qt-declarative-${PV}-r9999
38 !<x11-libs/qt-demo-${PV} 46 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999 47 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV} 48 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999 49 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV} 50 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999 51 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV} 52 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999 53 !>x11-libs/qt-opengl-${PV}-r9999
54 !<x11-libs/qt-openvg-${PV}
55 !>x11-libs/qt-openvg-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV} 56 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999 57 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV} 58 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999 59 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV} 60 !<x11-libs/qt-script-${PV}
63 73
64S=${WORKDIR}/${MY_P} 74S=${WORKDIR}/${MY_P}
65 75
66# @FUNCTION: qt4-build_pkg_setup 76# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 77# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 78# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 79qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 80 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71 81
72 # Protect users by not allowing downgrades between releases 82 # Protect users by not allowing downgrades between releases
73 # Downgrading revisions within the same release should be allowed 83 # Downgrading revisions within the same release should be allowed
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 84 if has_version '>'${CATEGORY}/${P}-r9999; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 85 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 86 eerror "Sanity check to keep you from breaking your system:"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 87 eerror " Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 88 die "aborting to save your system"
79 else 89 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 90 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 91 fi
92 fi
93
94 if [[ ${PN} == qt-webkit ]]; then
95 eshopts_push -s extglob
96 if is-flagq '-g?(gdb)?([1-9])'; then
97 echo
98 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
99 ewarn "You may experience really long compilation times and/or increased memory usage."
100 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
101 ewarn "For more info check out bug #307861"
102 echo
103 fi
104 eshopts_pop
82 fi 105 fi
83 106
84 PATH="${S}/bin${PATH:+:}${PATH}" 107 PATH="${S}/bin${PATH:+:}${PATH}"
85 if [[ ${CHOST} != *-darwin* ]]; then 108 if [[ ${CHOST} != *-darwin* ]]; then
86 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 109 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
92 [[ ${CHOST} == *-apple-darwin* ]] && \ 115 [[ ${CHOST} == *-apple-darwin* ]] && \
93 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 116 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
94 ${QT4_EXTRACT_DIRECTORIES}" 117 ${QT4_EXTRACT_DIRECTORIES}"
95 fi 118 fi
96 119
97 # Make sure ebuilds use the required EAPI
98 if [[ ${EAPI} != [23] ]]; then
99 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
100 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
101 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
102 die "qt4-build eclass requires EAPI=2 or EAPI=3"
103 fi
104
105 if ! version_is_at_least 4.1 $(gcc-version); then 120 if ! version_is_at_least 4.1 $(gcc-version); then
106 ewarn "Using a GCC version lower than 4.1 is not supported!" 121 ewarn "Using a GCC version lower than 4.1 is not supported."
107 fi 122 fi
108} 123}
109 124
110# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
111# @DESCRIPTION: 126# @DESCRIPTION:
112# Arguments for build_target_directories. Takes the directories, in which the 127# Arguments for build_target_directories. Takes the directories in which the
113# code should be compiled. This is a space-separated list 128# code should be compiled. This is a space-separated list.
114 129
115# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
116# @DESCRIPTION: 131# @DESCRIPTION:
117# Space separated list including the directories that will be extracted from Qt 132# Space-separated list including the directories that will be extracted from
118# tarball 133# Qt tarball.
119 134
120# @FUNCTION: qt4-build_src_unpack 135# @FUNCTION: qt4-build_src_unpack
121# @DESCRIPTION: 136# @DESCRIPTION:
122# Unpacks the sources 137# Unpacks the sources.
123qt4-build_src_unpack() { 138qt4-build_src_unpack() {
124 setqtenv 139 setqtenv
125 local target targets= 140
141 local tarball="${MY_P}.tar.gz" target= targets=
126 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 142 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
127 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 143 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
128 ${QT4_EXTRACT_DIRECTORIES}; do 144 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
145 do
129 targets+=" ${MY_P}/${target}" 146 targets+="${MY_P}/${target} "
130 done 147 done
131 148
149 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
132 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 150 tar -xzf "${DISTDIR}/${tarball}" ${targets}
133 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 151 eend $? || die "failed to unpack"
134} 152}
135 153
136# @ECLASS-VARIABLE: PATCHES 154# @ECLASS-VARIABLE: PATCHES
155# @DEFAULT_UNSET
137# @DESCRIPTION: 156# @DESCRIPTION:
138# In case you have patches to apply, specify them in PATCHES variable. Make sure 157# PATCHES array variable containing all various patches to be applied.
139# to specify the full path. This variable is necessary for src_prepare phase. 158# This variable is expected to be defined in global scope of ebuild.
140# example: 159# Make sure to specify the full path. This variable is utilised in
141# PATCHES="${FILESDIR}"/mypatch.patch 160# src_unpack/src_prepare phase, based on EAPI.
142# ${FILESDIR}"/mypatch2.patch"
143# 161#
162# @CODE
163# PATCHES=( "${FILESDIR}/mypatch.patch"
164# "${FILESDIR}/patches_folder/" )
165# @CODE
144 166
145# @FUNCTION: qt4-build_src_prepare 167# @FUNCTION: qt4-build_src_prepare
146# @DESCRIPTION: 168# @DESCRIPTION:
147# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
148# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 170# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
149qt4-build_src_prepare() { 171qt4-build_src_prepare() {
150 setqtenv 172 setqtenv
151 cd "${S}" 173 cd "${S}"
152 174
175 if version_is_at_least 4.7; then
176 # fix libX11 dependency on non X packages
177 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
178 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
179
180 qt_assistant_cleanup
181 fi
182
153 if use aqua; then 183 if use aqua; then
154 # provide a proper macx-g++-64 184 # provide a proper macx-g++-64
155 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 185 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
156 186
157 sed -e '/^CONFIG/s:app_bundle::' \ 187 sed -e '/^CONFIG/s:app_bundle::' \
158 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 188 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
159 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 189 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
160 fi 190 fi
161 191
162 if [[ ${PN} != qt-core ]]; then 192 if [[ ${PN} != qt-core ]]; then
163 skip_qmake_build_patch 193 skip_qmake_build
164 skip_project_generation_patch 194 skip_project_generation
165 symlink_binaries_to_buildtree 195 symlink_binaries_to_buildtree
166 fi 196 fi
167 197
168 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 198 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
169 # qmake bus errors with -O2 but -O3 works 199 # qmake bus errors with -O2 but -O3 works
170 replace-flags -O2 -O3 200 replace-flags -O2 -O3
171 fi 201 fi
172
173 # Bug 282984 && Bug 295530
174 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
175 -i configure || die "sed qmake compilers failed"
176 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
177 -i config.tests/unix/compile.test || die "sed test compilers failed"
178 202
179 # Bug 178652 203 # Bug 178652
180 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 204 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
181 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 205 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
182 append-flags -fno-gcse 206 append-flags -fno-gcse
183 fi 207 fi
184 208
209 if use_if_iuse c++0x; then
210 echo
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 echo
217 append-flags -std=c++0x
218 fi
219
185 # Unsupported old gcc versions - hardened needs this :( 220 # Unsupported old gcc versions - hardened needs this :(
186 if [[ $(gcc-major-version) -lt 4 ]] ; then 221 if [[ $(gcc-major-version) -lt 4 ]]; then
187 ewarn "Appending -fno-stack-protector to CXXFLAGS" 222 ewarn "Appending -fno-stack-protector to CXXFLAGS"
188 append-cxxflags -fno-stack-protector 223 append-cxxflags -fno-stack-protector
189 # Bug 253127 224 # Bug 253127
190 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 225 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
191 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 226 -i mkspecs/common/g++.conf || die
192 fi 227 fi
193 228
194 # Bug 261632 229 # Bug 261632
195 if use ppc64; then 230 if use ppc64; then
196 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 231 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
197 append-flags -mminimal-toc 232 append-flags -mminimal-toc
198 fi 233 fi
199 234
235 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
236 sed -e "/^SYSTEM_VARIABLES=/i \
237 CC='$(tc-getCC)'\n\
238 CXX='$(tc-getCXX)'\n\
239 CFLAGS='${CFLAGS}'\n\
240 CXXFLAGS='${CXXFLAGS}'\n\
241 LDFLAGS='${LDFLAGS}'\n" \
242 -i configure \
243 || die "sed SYSTEM_VARIABLES failed"
244
245 # Respect CC, CXX, LINK and *FLAGS in config.tests
246 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
247 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
248 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
249 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
250 || die "sed config.tests failed"
251
252 # Strip predefined CFLAGS from mkspecs (bug 312689)
253 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
254
200 # Bug 172219 255 # Bug 172219
201 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 256 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
202 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
203 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
204 -e "s:X11R6/::" \
205 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
206 257
207 if [[ ${CHOST} != *-darwin* ]]; then 258 if [[ ${CHOST} == *-darwin* ]]; then
208 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
209 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
210 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
211 -i mkspecs/common/g++.conf || die "sed mkspecs/common/g++.conf failed"
212 else
213 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 259 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
214 # crippled (by design) :/ 260 # crippled (by design) :/
261 sed \
215 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 262 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
216 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 263 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
217 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 264 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
218 -e "s:-arch\s\w*::g" \ 265 -e "s:-arch\s\w*::g" \
219 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 266 -i mkspecs/common/mac-g++.conf \
267 || die "sed mkspecs/common/mac-g++.conf failed"
220 268
221 # Fix configure's -arch settings that appear in qmake/Makefile and also 269 # Fix configure's -arch settings that appear in qmake/Makefile and also
222 # fix arch handling (automagically duplicates our -arch arg and breaks 270 # fix arch handling (automagically duplicates our -arch arg and breaks
223 # pch). Additionally disable Xarch support. 271 # pch). Additionally disable Xarch support.
224 sed \ 272 sed \
229 -e "s:-arch \$i::" \ 277 -e "s:-arch \$i::" \
230 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 278 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
231 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 279 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
232 -e "s:-Xarch_x86_64::g" \ 280 -e "s:-Xarch_x86_64::g" \
233 -e "s:-Xarch_ppc64::g" \ 281 -e "s:-Xarch_ppc64::g" \
234 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 282 -i configure mkspecs/common/mac-g++.conf \
283 || die "sed -arch/-Xarch failed"
235 284
236 # On Snow Leopard don't fall back to 10.5 deployment target. 285 # On Snow Leopard don't fall back to 10.5 deployment target.
237 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 286 if [[ ${CHOST} == *-apple-darwin10 ]]; then
238 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
239 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
240 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 289 -i configure mkspecs/common/mac-g++.conf \
290 || die "sed deployment target failed"
241 fi 291 fi
242 fi 292 fi
243 293
244 # this one is needed for all systems with a separate -liconv, apart from 294 # this one is needed for all systems with a separate -liconv, apart from
245 # Darwin, for which the sources already cater for -liconv 295 # Darwin, for which the sources already cater for -liconv
246 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 296 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
247 sed \ 297 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
248 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
249 -i config.tests/unix/iconv/iconv.pro \ 298 -i config.tests/unix/iconv/iconv.pro \
250 || die "sed on iconv.pro failed" 299 || die "sed iconv.pro failed"
251 fi 300 fi
252 301
253 # we need some patches for Solaris 302 # we need some patches for Solaris
254 sed -i \
255 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 303 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
256 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 304 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
257 # use GCC over SunStudio 305 # use GCC over SunStudio
258 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 306 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
259 # don't flirt with non-Prefix stuff, we're quite possessive 307 # do not flirt with non-Prefix stuff, we're quite possessive
260 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 308 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
261 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 309 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
262 310
263 base_src_prepare 311 base_src_prepare
264} 312}
266# @FUNCTION: qt4-build_src_configure 314# @FUNCTION: qt4-build_src_configure
267# @DESCRIPTION: 315# @DESCRIPTION:
268# Default configure phase 316# Default configure phase
269qt4-build_src_configure() { 317qt4-build_src_configure() {
270 setqtenv 318 setqtenv
271 myconf="$(standard_configure_options) ${myconf}" 319
320 local conf="
321 -prefix ${QTPREFIXDIR}
322 -bindir ${QTBINDIR}
323 -libdir ${QTLIBDIR}
324 -docdir ${QTDOCDIR}
325 -headerdir ${QTHEADERDIR}
326 -plugindir ${QTPLUGINDIR}
327 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
328 -datadir ${QTDATADIR}
329 -translationdir ${QTTRANSDIR}
330 -sysconfdir ${QTSYSCONFDIR}
331 -examplesdir ${QTEXAMPLESDIR}
332 -demosdir ${QTDEMOSDIR}
333 -opensource -confirm-license
334 -shared -fast -largefile -stl -verbose
335 -nomake examples -nomake demos"
336
337 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
338 # $(tc-arch). Therefore we convert it to supported values.
339 case "$(tc-arch)" in
340 amd64|x64-*) conf+=" -arch x86_64" ;;
341 ppc-macos) conf+=" -arch ppc" ;;
342 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
343 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
344 x86-macos) conf+=" -arch x86" ;;
345 x86|x86-*) conf+=" -arch i386" ;;
346 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
347 hppa|sh) conf+=" -arch generic" ;;
348 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
349 esac
350
351 conf+=" -platform $(qt_mkspecs_dir)"
352
353 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
354
355 # debug/release
356 if use debug; then
357 conf+=" -debug"
358 else
359 conf+=" -release"
360 fi
361 conf+=" -no-separate-debug-info"
362
363 # exceptions USE flag
364 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
365
366 # disable RPATH on Qt >= 4.8 (bug 380415)
367 version_is_at_least 4.8 && conf+=" -no-rpath"
368
369 # precompiled headers don't work on hardened, where the flag is masked
370 conf+=" $(qt_use pch)"
371
372 # -reduce-relocations
373 # This flag seems to introduce major breakage to applications,
374 # mostly to be seen as a core dump with the message "QPixmap: Must
375 # construct a QApplication before a QPaintDevice" on Solaris.
376 # -- Daniel Vergien
377 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
272 378
273 # this one is needed for all systems with a separate -liconv, apart from 379 # this one is needed for all systems with a separate -liconv, apart from
274 # Darwin, for which the sources already cater for -liconv 380 # Darwin, for which the sources already cater for -liconv
275 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 381 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
276 myconf+=" -liconv" 382 conf+=" -liconv"
383 fi
277 384
278 if has glib ${IUSE//+} && use glib; then 385 if use_if_iuse glib; then
279 # use -I, -L and -l from configure
280 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 386 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
281 # avoid the -pthread argument 387 # avoid the -pthread argument
282 myconf+=" ${glibflags//-pthread}" 388 conf+=" ${glibflags//-pthread}"
283 unset glibflags 389 unset glibflags
284 fi 390 fi
285 391
392 if use_if_iuse qpa; then
393 echo
394 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
395 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
396 ewarn "disable it before reporting any bugs related to this useflag."
397 echo
398 conf+=" -qpa"
399 fi
400
286 if use aqua ; then 401 if use aqua; then
287 # On (snow) leopard use the new (frameworked) cocoa code. 402 # On (snow) leopard use the new (frameworked) cocoa code.
288 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 403 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
289 myconf+=" -cocoa -framework" 404 conf+=" -cocoa -framework"
405 # We need the source's headers, not the installed ones.
406 conf+=" -I${S}/include"
407 # Add hint for the framework location.
408 conf+=" -F${QTLIBDIR}"
290 409
291 # We are crazy and build cocoa + qt3support :-) 410 # We are crazy and build cocoa + qt3support :-)
292 if use qt3support; then 411 if use qt3support; then
293 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 412 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
294 -i configure 413 -i configure || die
295 fi 414 fi
296 415 else
297 # We need the source's headers, not the installed ones. 416 conf+=" -no-framework"
298 myconf+=" -I${S}/include"
299
300 # Add hint for the framework location.
301 myconf+=" -F${QTLIBDIR}"
302 fi 417 fi
303 else 418 else
304 # freetype2 include dir is non-standard, thus include it on configure 419 # freetype2 include dir is non-standard, thus pass it to configure
305 # use -I from configure
306 myconf+=" $(pkg-config --cflags freetype2)" 420 conf+=" $(pkg-config --cflags-only-I freetype2)"
307 fi 421 fi
308 422
423 conf+=" ${myconf}"
424 myconf=
425
309 echo ./configure ${myconf} 426 echo ./configure ${conf}
310 ./configure ${myconf} || die "./configure failed" 427 ./configure ${conf} || die "./configure failed"
311 myconf="" 428
429 prepare_directories ${QT4_TARGET_DIRECTORIES}
312} 430}
313 431
314# @FUNCTION: qt4-build_src_compile 432# @FUNCTION: qt4-build_src_compile
433# @DESCRIPTION:
315# @DESCRIPTION: Actual compile phase 434# Actual compile phase
316qt4-build_src_compile() { 435qt4-build_src_compile() {
317 setqtenv 436 setqtenv
318 437
319 build_directories ${QT4_TARGET_DIRECTORIES} 438 build_directories ${QT4_TARGET_DIRECTORIES}
320} 439}
321 440
441# @FUNCTION: qt4-build_src_test
442# @DESCRIPTION:
443# Runs tests only in target directories.
444qt4-build_src_test() {
445 # QtMultimedia does not have any test suite (bug #332299)
446 [[ ${PN} == qt-multimedia ]] && return
447
448 for dir in ${QT4_TARGET_DIRECTORIES}; do
449 emake -j1 check -C ${dir}
450 done
451}
452
322# @FUNCTION: fix_includes 453# @FUNCTION: fix_includes
323# @DESCRIPTION: 454# @DESCRIPTION:
324# For MacOSX we need to add some symlinks when frameworks are 455# For MacOS X we need to add some symlinks when frameworks are
325# being used, to avoid complications with some more or less stupid packages. 456# being used, to avoid complications with some more or less stupid packages.
326fix_includes() { 457fix_includes() {
327 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 458 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
328 # Some packages tend to include <Qt/...> 459 # Some packages tend to include <Qt/...>
329 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 460 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
330 461
331 # Fake normal headers when frameworks are installed... eases life later on 462 # Fake normal headers when frameworks are installed... eases life later on
332 local dest f 463 local dest f h
333 for frw in "${D}${QTLIBDIR}"/*.framework; do 464 for frw in "${D}${QTLIBDIR}"/*.framework; do
334 [[ -e "${frw}"/Headers ]] || continue 465 [[ -e "${frw}"/Headers ]] || continue
335 f=$(basename ${frw}) 466 f=$(basename ${frw})
336 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 467 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
337 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 468 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
349# @DESCRIPTION: 480# @DESCRIPTION:
350# Perform the actual installation including some library fixes. 481# Perform the actual installation including some library fixes.
351qt4-build_src_install() { 482qt4-build_src_install() {
352 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 483 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
353 setqtenv 484 setqtenv
485
354 install_directories ${QT4_TARGET_DIRECTORIES} 486 install_directories ${QT4_TARGET_DIRECTORIES}
355 install_qconfigs 487 install_qconfigs
356 fix_library_files 488 fix_library_files
357 fix_includes 489 fix_includes
490
491 # remove .la files since we are building only shared Qt libraries
492 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
358} 493}
359 494
360# @FUNCTION: setqtenv 495# @FUNCTION: setqtenv
496# @INTERNAL
361setqtenv() { 497setqtenv() {
362 # Set up installation directories 498 # Set up installation directories
363 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
364 QTPREFIXDIR=${EPREFIX}/usr 499 QTPREFIXDIR=${EPREFIX}/usr
365 QTBINDIR=${EPREFIX}/usr/bin 500 QTBINDIR=${EPREFIX}/usr/bin
366 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 501 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
367 QMAKE_LIBDIR_QT=${QTLIBDIR}
368 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 502 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
369 QTDATADIR=${EPREFIX}/usr/share/qt4
370 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 503 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
371 QTHEADERDIR=${EPREFIX}/usr/include/qt4 504 QTHEADERDIR=${EPREFIX}/usr/include/qt4
372 QTPLUGINDIR=${QTLIBDIR}/plugins 505 QTPLUGINDIR=${QTLIBDIR}/plugins
506 QTIMPORTDIR=${QTLIBDIR}/imports
507 QTDATADIR=${EPREFIX}/usr/share/qt4
508 QTTRANSDIR=${QTDATADIR}/translations
373 QTSYSCONFDIR=${EPREFIX}/etc/qt4 509 QTSYSCONFDIR=${EPREFIX}/etc/qt4
374 QTTRANSDIR=${QTDATADIR}/translations
375 QTEXAMPLESDIR=${QTDATADIR}/examples 510 QTEXAMPLESDIR=${QTDATADIR}/examples
376 QTDEMOSDIR=${QTDATADIR}/demos 511 QTDEMOSDIR=${QTDATADIR}/demos
512 QMAKE_LIBDIR_QT=${QTLIBDIR}
377 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 513 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
514
378 PLATFORM=$(qt_mkspecs_dir) 515 PLATFORM=$(qt_mkspecs_dir)
379 516
380 unset QMAKESPEC 517 unset QMAKESPEC
381} 518}
382 519
383# @FUNCTION: standard_configure_options
384# @DESCRIPTION:
385# Sets up some standard configure options, like libdir (if necessary), whether
386# debug info is wanted or not.
387standard_configure_options() {
388 local myconf=
389
390 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
391
392 # Disable visibility explicitly if gcc version isn't 4
393 if [[ $(gcc-major-version) -lt 4 ]]; then
394 myconf+=" -no-reduce-exports"
395 fi
396
397 # precompiled headers doesn't work on hardened, where the flag is masked.
398 myconf+=" $(qt_use pch)"
399
400 if use debug; then
401 myconf+=" -debug"
402 else
403 myconf+=" -release"
404 fi
405 myconf+=" -no-separate-debug-info"
406
407 use aqua && myconf+=" -no-framework"
408
409 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
410 # $(tc-arch). Therefore we convert it to supported values.
411 case "$(tc-arch)" in
412 amd64|x64-*) myconf+=" -arch x86_64" ;;
413 ppc-macos) myconf+=" -arch ppc" ;;
414 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
415 sparc|sparc-*) myconf+=" -arch sparc" ;;
416 x86-macos) myconf+=" -arch x86" ;;
417 x86|x86-*) myconf+=" -arch i386" ;;
418 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
419 hppa|sh) myconf+=" -arch generic" ;;
420 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
421 esac
422
423 # 4.5: build everything but qt-xmlpatterns w/o exceptions
424 # 4.6: exceptions USE flag
425 local exceptions="-exceptions"
426 case "${PV}" in
427 4.5.*)
428 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
429 ;;
430 *)
431 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
432 ;;
433 esac
434
435 # note about -reduce-relocations:
436 # That flag seems to introduce major breakage to applications,
437 # mostly to be seen as a core dump with the message "QPixmap: Must
438 # construct a QApplication before a QPaintDevice" on Solaris
439 # -- Daniel Vergien
440 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
441
442 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
443 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
444 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
445 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
446 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
447 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
448 ${exceptions}
449 -nomake examples -nomake demos"
450
451 echo "${myconf}"
452}
453
454# @FUNCTION: build_directories 520# @FUNCTION: prepare_directories
455# @USAGE: < directories > 521# @USAGE: < directories >
522# @INTERNAL
456# @DESCRIPTION: 523# @DESCRIPTION:
457# Compiles the code in $QT4_TARGET_DIRECTORIES 524# Generates Makefiles for the given list of directories.
458build_directories() { 525prepare_directories() {
459 for x in "$@"; do 526 for x in "$@"; do
460 pushd "${S}"/${x} >/dev/null 527 pushd "${S}"/${x} >/dev/null || die
528 einfo "Running qmake in: ${x}"
461 # avoid running over the maximum argument number, bug #299810 529 # avoid running over the maximum argument number, bug #299810
462 { 530 {
463 echo "${S}"/mkspecs/common/*.conf 531 echo "${S}"/mkspecs/common/*.conf
464 find "${S}" -name '*.pr[io]' 532 find "${S}" -name '*.pr[io]'
465 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 533 } | xargs sed -i \
534 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
535 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
536 || die
466 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 537 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
467 emake CC="@echo compiling \$< && $(tc-getCC)" \
468 CXX="@echo compiling \$< && $(tc-getCXX)" \
469 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed"
470 popd >/dev/null 538 popd >/dev/null || die
539 done
540}
541
542
543# @FUNCTION: build_directories
544# @USAGE: < directories >
545# @INTERNAL
546# @DESCRIPTION:
547# Compiles the code in the given list of directories.
548build_directories() {
549 for x in "$@"; do
550 pushd "${S}"/${x} >/dev/null || die
551 emake CC="$(tc-getCC)" \
552 CXX="$(tc-getCXX)" \
553 LINK="$(tc-getCXX)" || die "emake failed"
554 popd >/dev/null || die
471 done 555 done
472} 556}
473 557
474# @FUNCTION: install_directories 558# @FUNCTION: install_directories
475# @USAGE: < directories > 559# @USAGE: < directories >
560# @INTERNAL
476# @DESCRIPTION: 561# @DESCRIPTION:
477# run emake install in the given directories, which are separated by spaces 562# Runs emake install in the given directories, which are separated by spaces.
478install_directories() { 563install_directories() {
479 for x in "$@"; do 564 for x in "$@"; do
480 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 565 pushd "${S}"/${x} >/dev/null || die
481 emake INSTALL_ROOT="${D}" install || die "emake install failed" 566 emake INSTALL_ROOT="${D}" install || die "emake install failed"
482 popd >/dev/null || die "Can't popd from ${S}/${x}" 567 popd >/dev/null || die
483 done 568 done
484} 569}
485 570
486# @ECLASS-VARIABLE: QCONFIG_ADD 571# @ECLASS-VARIABLE: QCONFIG_ADD
487# @DESCRIPTION: 572# @DESCRIPTION:
497# @DESCRIPTION: 582# @DESCRIPTION:
498# List variables that should be defined at the top of QtCore/qconfig.h 583# List variables that should be defined at the top of QtCore/qconfig.h
499: ${QCONFIG_DEFINE:=} 584: ${QCONFIG_DEFINE:=}
500 585
501# @FUNCTION: install_qconfigs 586# @FUNCTION: install_qconfigs
587# @INTERNAL
588# @DESCRIPTION:
502# @DESCRIPTION: Install gentoo-specific mkspecs configurations 589# Install gentoo-specific mkspecs configurations.
503install_qconfigs() { 590install_qconfigs() {
504 local x 591 local x
505 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 592 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
506 for x in QCONFIG_ADD QCONFIG_REMOVE; do 593 for x in QCONFIG_ADD QCONFIG_REMOVE; do
507 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 594 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
518 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 605 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
519 fi 606 fi
520} 607}
521 608
522# @FUNCTION: generate_qconfigs 609# @FUNCTION: generate_qconfigs
523# @DESCRIPTION: Generates gentoo-specific configurations 610# @INTERNAL
611# @DESCRIPTION:
612# Generates gentoo-specific qconfig.{h,pri}.
524generate_qconfigs() { 613generate_qconfigs() {
525 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 614 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
526 local x qconfig_add qconfig_remove qconfig_new 615 local x qconfig_add qconfig_remove qconfig_new
527 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 616 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
528 [[ -f ${x} ]] || continue 617 [[ -f ${x} ]] || continue
529 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 618 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
530 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 619 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
542 631
543 # generate list of QT_CONFIG entries from the existing list 632 # generate list of QT_CONFIG entries from the existing list
544 # including qconfig_add and excluding qconfig_remove 633 # including qconfig_add and excluding qconfig_remove
545 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 634 for x in $(sed -n 's/^QT_CONFIG +=//p' \
546 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
547 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 636 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
548 done 637 done
549 638
550 # replace the existing QT_CONFIG list with qconfig_new 639 # replace the existing QT_CONFIG list with qconfig_new
551 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 640 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
552 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 641 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
576 fi 665 fi
577 fi 666 fi
578} 667}
579 668
580# @FUNCTION: qt4-build_pkg_postrm 669# @FUNCTION: qt4-build_pkg_postrm
670# @DESCRIPTION:
581# @DESCRIPTION: Generate configurations when the package is completely removed 671# Regenerate configuration when the package is completely removed.
582qt4-build_pkg_postrm() { 672qt4-build_pkg_postrm() {
583 generate_qconfigs 673 generate_qconfigs
584} 674}
585 675
586# @FUNCTION: qt4-build_pkg_postinst 676# @FUNCTION: qt4-build_pkg_postinst
677# @DESCRIPTION:
587# @DESCRIPTION: Generate configuration, plus throws a message about possible 678# Regenerate configuration, plus throw a message about possible
588# breakages and proposed solutions. 679# breakages and proposed solutions.
589qt4-build_pkg_postinst() { 680qt4-build_pkg_postinst() {
590 generate_qconfigs 681 generate_qconfigs
591} 682}
592 683
593# @FUNCTION: skip_qmake_build_patch 684# @FUNCTION: skip_qmake_build
685# @INTERNAL
594# @DESCRIPTION: 686# @DESCRIPTION:
595# Don't need to build qmake, as it's already installed from qt-core 687# Patches configure to skip qmake compilation, as it's already installed by qt-core.
596skip_qmake_build_patch() { 688skip_qmake_build() {
597 # Don't need to build qmake, as it's already installed from qt-core
598 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 689 sed -i -e "s:if true:if false:g" "${S}"/configure || die
599} 690}
600 691
601# @FUNCTION: skip_project_generation_patch 692# @FUNCTION: skip_project_generation
693# @INTERNAL
602# @DESCRIPTION: 694# @DESCRIPTION:
603# Exit the script early by throwing in an exit before all of the .pro files are scanned 695# Exit the script early by throwing in an exit before all of the .pro files are scanned.
604skip_project_generation_patch() { 696skip_project_generation() {
605 # Exit the script early by throwing in an exit before all of the .pro files are scanned
606 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 697 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
607 -i "${S}"/configure || die "Sed failed"
608} 698}
609 699
610# @FUNCTION: symlink_binaries_to_buildtree 700# @FUNCTION: symlink_binaries_to_buildtree
701# @INTERNAL
611# @DESCRIPTION: 702# @DESCRIPTION:
612# Symlink generated binaries to buildtree so they can be used during compilation 703# Symlinks generated binaries to buildtree, so they can be used during compilation time.
613# time
614symlink_binaries_to_buildtree() { 704symlink_binaries_to_buildtree() {
615 for bin in qmake moc uic rcc; do 705 for bin in qmake moc uic rcc; do
616 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 706 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
617 done 707 done
618} 708}
619 709
620# @FUNCTION: fix_library_files 710# @FUNCTION: fix_library_files
711# @INTERNAL
621# @DESCRIPTION: 712# @DESCRIPTION:
622# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 713# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
623# moves the *.pc-files into the pkgconfig directory 714# moves the *.pc files into the pkgconfig directory.
624fix_library_files() { 715fix_library_files() {
716 local libfile
625 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 717 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
626 if [[ -e ${libfile} ]]; then 718 if [[ -e ${libfile} ]]; then
627 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 719 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
628 fi 720 fi
629 done 721 done
630 722
631 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 723 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
632 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 724 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
633 if [[ -e ${libfile} ]]; then 725 if [[ -e ${libfile} ]]; then
634 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 726 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
635 727
636 # Move .pc files into the pkgconfig directory 728 # Move .pc files into the pkgconfig directory
637 dodir ${QTPCDIR#${EPREFIX}} 729 dodir ${QTPCDIR#${EPREFIX}}
638 mv ${libfile} "${D}"/${QTPCDIR}/ \ 730 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
639 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
640 fi 731 fi
641 done 732 done
642 733
643 # Don't install an empty directory 734 # Don't install an empty directory
644 rmdir "${D}"/${QTLIBDIR}/pkgconfig 735 rmdir "${D}"/${QTLIBDIR}/pkgconfig
645} 736}
646 737
647# @FUNCTION: qt_use 738# @FUNCTION: qt_use
648# @USAGE: < flag > [ feature ] [ enableval ] 739# @USAGE: < flag > [ feature ] [ enableval ]
649# @DESCRIPTION: 740# @DESCRIPTION:
650# This will echo "${enableval}-${feature}" if <flag> is enabled, or 741# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
651# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 742# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
652# will be used for that. If [enableval] is not specified, it omits the 743# will be used for that. If [enableval] is not specified, it omits the
653# assignment-part 744# "-${enableval}" part.
654qt_use() { 745qt_use() {
655 local flag=$1 746 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
656 local feature=$1
657 local enableval=
658
659 [[ -n $2 ]] && feature=$2
660 [[ -n $3 ]] && enableval=-$3
661
662 if use ${flag}; then
663 echo "${enableval}-${feature}"
664 else
665 echo "-no-${feature}"
666 fi
667} 747}
668 748
669# @FUNCTION: qt_mkspecs_dir 749# @FUNCTION: qt_mkspecs_dir
670# @RETURN: the specs-directory w/o path 750# @RETURN: the specs-directory w/o path
671# @DESCRIPTION: 751# @DESCRIPTION:
672# Allows us to define which mkspecs dir we want to use. 752# Allows us to define which mkspecs dir we want to use.
673qt_mkspecs_dir() { 753qt_mkspecs_dir() {
674 # Allows us to define which mkspecs dir we want to use.
675 local spec 754 local spec=
676 755
677 case ${CHOST} in 756 case "${CHOST}" in
678 *-freebsd*|*-dragonfly*) 757 *-freebsd*|*-dragonfly*)
679 spec=freebsd ;; 758 spec=freebsd ;;
680 *-openbsd*) 759 *-openbsd*)
681 spec=openbsd ;; 760 spec=openbsd ;;
682 *-netbsd*) 761 *-netbsd*)
693 *-solaris*) 772 *-solaris*)
694 spec=solaris ;; 773 spec=solaris ;;
695 *-linux-*|*-linux) 774 *-linux-*|*-linux)
696 spec=linux ;; 775 spec=linux ;;
697 *) 776 *)
698 die "Unknown CHOST, no platform choosen." 777 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
699 esac 778 esac
700 779
701 CXX=$(tc-getCXX) 780 case "$(tc-getCXX)" in
702 if [[ ${CXX} == *g++* ]]; then 781 *g++*)
703 spec+=-g++ 782 spec+=-g++ ;;
704 elif [[ ${CXX} == *icpc* ]]; then 783 *icpc*)
705 spec+=-icc 784 spec+=-icc ;;
706 else 785 *)
707 die "Unknown compiler ${CXX}." 786 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
708 fi 787 esac
709 if [[ -n ${LIBDIR/lib} ]]; then
710 spec+=-${LIBDIR/lib}
711 fi
712 788
713 # Add -64 for 64bit profiles 789 # Add -64 for 64bit profiles
714 if use x64-freebsd || 790 if use x64-freebsd ||
715 use amd64-linux || 791 use amd64-linux ||
716 use x64-macos || 792 use x64-macos ||
721 fi 797 fi
722 798
723 echo "${spec}" 799 echo "${spec}"
724} 800}
725 801
802# @FUNCTION: qt_assistant_cleanup
803# @INTERNAL
804# @DESCRIPTION:
805# Tries to clean up tools.pro for qt-assistant ebuilds.
806# Meant to be called in src_prepare().
807# Since Qt 4.7.4 this function is a no-op.
808qt_assistant_cleanup() {
809 # apply patching to qt-assistant ebuilds only
810 [[ ${PN} != qt-assistant ]] && return
811
812 # no longer needed for 4.7.4 and later
813 version_is_at_least 4.7.4 && return
814
815 # different versions (and branches...) may need different handling,
816 # add a case if you need special handling
817 case "${MY_PV_EXTRA}" in
818 *kde-qt*)
819 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
820 -e "/mac/,/^embedded.*makeqpf$/d" \
821 -i tools/tools.pro || die "patching tools.pro failed"
822 ;;
823 *)
824 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
825 -e "/mac/,/^embedded.*makeqpf$/d" \
826 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
827 -i tools/tools.pro || die "patching tools.pro failed"
828 ;;
829 esac
830}
831
832# @FUNCTION: qt_nolibx11
833# @INTERNAL
834# @DESCRIPTION:
835# Ignore X11 tests for packages that don't need X libraries installed.
836qt_nolibx11() {
837 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
838 die "x11 check sed failed"
839}
840
726EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 841EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.123

  ViewVC Help
Powered by ViewVC 1.1.20